# RtMovementSnapperInfo Struct Reference

List of all members.

## Public Attributes
RtUlong | dwDimension
RtVector3f | vtAxes [3]
RtFloat | fSteps [3]
RtUlong | dwPrevDimension
RtVector3f | vtPrevAxes [3]
RtPoint | ptInitialPosition
RtPoint | ptActualPosition
RtMatrixf | mCoordSys
RtMatrixf | mCoordSysInv
RtPositionSnapMode | mSelectionMode
RtUlong | dwSkipElements

## Detailed Description

Structure that holds snapping information that user needs to fill when calling snapper manager.

## Member Data Documentation

RtUlong RtMovementSnapperInfo::dwDimension

Defines dimension of movement space. When calling snapping manager, set to 3 and initialize vtAxes with orthonormal basis to allow full 3D movement in all directions.

RtVector3f RtMovementSnapperInfo::vtAxes[3]

Defines orthonormal basis of movement space.

RtFloat RtMovementSnapperInfo::fSteps[3]

Defines steps for each axis.

RtUlong RtMovementSnapperInfo::dwPrevDimension

Defines input dimension of previous snapping phase. In constraint calculation, it defines input movement constraint space, in position snapping phase it defines space before applying soft constraints.

This field is handled by snapping management and should not be changed.

RtVector3f RtMovementSnapperInfo::vtPrevAxes[3]

Defines input basis of previous snapping phase. In constraint calculation, it defines input movement constraint space, in position snapping phase it defines space before applying soft constraints.

This field is handled by snapping management and should not be changed.

RtPoint RtMovementSnapperInfo::ptInitialPosition

Defines initial position of movement (eg. position of widget when user starts dragging). This can be used to calculate exact position when constraining movement to reduce numerical errors).

RtPoint RtMovementSnapperInfo::ptActualPosition

Current non-snapped position for snapping.

RtMatrixf RtMovementSnapperInfo::mCoordSys

Selected coordinate system. This can be used for tools that depend on selected coordinate system.

RtMatrixf RtMovementSnapperInfo::mCoordSysInv

Inverse coordinate system, provided for tool convenience.

RtPositionSnapMode RtMovementSnapperInfo::mSelectionMode

Enable to allow using selections to perform snapping on selected elements level

RtUlong RtMovementSnapperInfo::dwSkipElements

Element types caller wish to be ignored for snapping.